#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"

#define RQ_SET_LED    0
#define RQ_GET_SWITCH 1

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;
    static uint8_t switch_state;  /* must stay valid when usbFunctionSetup returns */

    if (rq->bRequest == RQ_SET_LED)
    {
        uint8_t led_val = rq->wValue.bytes[0];
        uint8_t led_no  = rq->wIndex.bytes[0];

        if (led_val)
            PORTC |= (1<<led_no);
        else
            PORTC &= ~(1<<led_no);

        return 0;
    }

    else if (rq->bRequest == RQ_GET_SWITCH)
    {
        if ((PINC & (1<<PC3)) == 0) /* switch is pressed */
            switch_state = 1;
        else
            switch_state = 0;

        /* point usbMsgPtr to the data to be returned to host */
        usbMsgPtr = (uchar*) &switch_state;

        /* return the number of bytes of data to be returned to host */
        return sizeof(switch_state);
    }

    return 0;   /* default for not implemented requests: return no data back to host */
}

/* ------------------------------------------------------------------------- */
#define time 500
#define Wait 100
#define spd 10
int main(void)
{

	int loopcontrol = 10;
	int loop = loopcontrol;
	int clk = 0;
	int clk2 = 0;
	int clock2 = 500;
	int clock = 50;	
	int LED = 1;
    while (1){
		_delay_ms(5000);
		while(clk2 != clock2)
		{
			while(LED != 28)
			{
				while(clk !=clock)
				{
				openblue(LED);
				clk ++;
			}
			clk = 0;
			LED ++;
		}
		clk2 ++;
		LED = 0;
		}
		openblue(0);
		_delay_ms(500);
		clk2 = 0;
		clk = 0;
		LED = 0;
		while(clk2 != clock2)
		{
			while(LED != 28)
			{
				while(clk !=clock)
				{
				openblue(LED);
				clk ++;
			}
			clk = 0;
			LED ++;
		}
		clk2 ++;
		LED = 0;
		}
		clock = 200;
		show_3x1_Motion('b','v',0,clock);
		show_3x1_Motion('b','v',1,clock);
		show_3x1_Motion('b','h',0,clock);
		show_3x1_Motion('b','h',1,clock);
		show_3x1_Motion('b','f',0,clock);
		show_3x1_Motion('b','f',1,clock);

		clock = 25;
		loop = 4;
		while(loop != 0){
		show_3x1_Motion('b','v',0,clock);
		show_3x1_Motion('b','v',1,clock);
		show_3x1_Motion('b','h',0,clock);
		show_3x1_Motion('b','h',1,clock);
		show_3x1_Motion('b','f',0,clock);
		show_3x1_Motion('b','f',1,clock);
		loop --;
		}
		loop = 10;
		show_3x3_Motion('b','v',0,0,clock);
		show_3x3_Motion('b','v',1,0,clock);		
		show_3x3_Motion('b','h',0,1,clock);
		show_3x3_Motion('b','h',1,1,clock);
		show_3x3_Motion('b','f',0,1,clock);
		show_3x3_Motion('b','f',1,1,clock);
		while (loop != 0){
		show_3x3_Motion('b','v',0,1,clock);
		clock -= 2;
		loop --;}
		loop = loopcontrol;
		while (loop != 0){
		show_3x3_Motion('b','v',0,1,clock);
		loop --;}
		loop = 5;
		while (loop != 0){
		show_3x3_Motion('r','h',1,1,clock);
		show_3x3_Motion('b','h',0,1,clock);			
		loop --;}
		loop = 5;
		while (loop != 0){
		show_3x3_Motion('b','h',1,1,clock);
		loop --;}
		loop = 7;
		while (loop != 0){
		show_3x3_Motion('r','f',1,1,clock);
		show_3x3_Motion('b','f',0,1,clock);			
		loop --;}
		while (loop != 0){
		show_3x3_Motion('b','f',1,1,clock);
		loop --;}
		loop = 5;
		while (loop != 0){
		show_3x3_Motion('r','h',1,1,clock);
		show_3x3_Motion('b','h',0,1,clock);			
		loop --;}
		loop = 7;
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','f',0,1,clock);
		show_3x3_Motion('r','h',1,1,clock);
		show_3x3_Motion('b','f',1,1,clock);
		show_3x3_Motion('b','h',1,1,clock);
		show_3x3_Motion('r','h',0,1,clock);
		show_3x3_Motion('r','f',1,1,clock);		
		show_3x3_Motion('b','v',0,1,clock);
		show_3x3_Motion('r','h',1,1,clock);
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','v',0,1,clock);
		show_3x3_Motion('b','f',1,1,clock);
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','h',1,1,clock);
		show_3x3_Motion('r','v',0,1,clock);
		show_3x3_Motion('r','f',1,1,clock);		
		show_3x3_Motion('b','f',0,1,clock);
		show_3x3_Motion('r','h',0,1,clock);
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','f',0,1,clock);
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','f',1,1,clock);
		show_3x3_Motion('b','h',1,1,clock);
		show_3x3_Motion('r','h',0,1,clock);
		show_3x3_Motion('r','v',1,1,clock);		
		show_3x3_Motion('b','f',0,1,clock);
		show_3x3_Motion('r','h',0,1,clock);
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','f',0,1,clock);
		show_3x3_Motion('r','h',1,1,clock);
		show_3x3_Motion('b','f',1,1,clock);
		show_3x3_Motion('b','h',1,1,clock);
		show_3x3_Motion('r','h',0,1,clock);
		show_3x3_Motion('r','f',1,1,clock);		
		show_3x3_Motion('b','v',0,1,clock);
		show_3x3_Motion('r','h',1,1,clock);
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','v',0,1,clock);
		show_3x3_Motion('b','f',1,1,clock);
		show_3x3_Motion('r','v',1,1,clock);
		show_3x3_Motion('b','h',1,1,clock);
		show_3x3_Motion('r','v',0,1,clock);
		show_3x3_Motion('r','f',1,1,clock);
		clock = 25;
		while(loop != 0)
		{
		Set_3x1_Direction('b','v',1,clock,0);
		Set_3x1_Direction('b','v',2,clock,0);
		Set_3x1_Direction('b','v',3,clock,0);
		Set_3x1_Direction('b','v',6,clock,0);
		Set_3x1_Direction('b','v',9,clock,0);
		Set_3x1_Direction('b','v',8,clock,0);
		Set_3x1_Direction('b','v',7,clock,0);
		Set_3x1_Direction('b','v',4,clock,0);
		
		Set_3x1_Direction('r','v',1,clock,0);
		Set_3x1_Direction('r','v',2,clock,0);
		Set_3x1_Direction('r','v',3,clock,0);
		Set_3x1_Direction('r','v',6,clock,0);
		Set_3x1_Direction('r','v',9,clock,0);
		Set_3x1_Direction('r','v',8,clock,0);
		Set_3x1_Direction('r','v',7,clock,0);
		Set_3x1_Direction('r','v',4,clock,0);
		loop-- ;
		}
		loop = 7;
		while(loop != 0)
		{
		Set_3x1_Direction('b','v',1,clock,0);
		Set_3x1_Direction('b','v',2,clock,0);
		Set_3x1_Direction('b','v',3,clock,0);
		Set_3x1_Direction('b','v',6,clock,0);
		Set_3x1_Direction('b','v',9,clock,0);
		Set_3x1_Direction('b','v',8,clock,0);
		Set_3x1_Direction('b','v',7,clock,0);
		Set_3x1_Direction('b','v',4,clock,0);
		loop --;
		}
		loop = 7;
		while(loop != 0)
		{
		Set_3x1_Direction('r','v',1,clock,0);
		Set_3x1_Direction('r','v',2,clock,0);
		Set_3x1_Direction('r','v',3,clock,0);
		Set_3x1_Direction('r','v',6,clock,0);
		Set_3x1_Direction('r','v',9,clock,0);
		Set_3x1_Direction('r','v',8,clock,0);
		Set_3x1_Direction('r','v',7,clock,0);
		Set_3x1_Direction('r','v',4,clock,0);
		loop --;
		}
		loop = 7;
		while(loop != 0)
		{
		Set_3x1_Direction('b','f',1,clock,0);
		Set_3x1_Direction('b','f',4,clock,0);
		Set_3x1_Direction('b','f',7,clock,0);
		Set_3x1_Direction('b','f',8,clock,0);
		Set_3x1_Direction('b','f',9,clock,0);
		Set_3x1_Direction('b','f',6,clock,0);
		Set_3x1_Direction('b','f',3,clock,0);
		Set_3x1_Direction('b','f',2,clock,0);
		
		Set_3x1_Direction('r','f',1,clock,0);
		Set_3x1_Direction('r','f',4,clock,0);
		Set_3x1_Direction('r','f',7,clock,0);
		Set_3x1_Direction('r','f',8,clock,0);
		Set_3x1_Direction('r','f',9,clock,0);
		Set_3x1_Direction('r','f',6,clock,0);
		Set_3x1_Direction('r','f',3,clock,0);
		Set_3x1_Direction('r','f',2,clock,0);
		loop-- ;
		}		
		loop = 7;
		while(loop != 0)
		{
		Set_3x1_Direction('b','f',1,clock,0);
		Set_3x1_Direction('b','f',2,clock,0);
		Set_3x1_Direction('b','f',3,clock,0);
		Set_3x1_Direction('b','f',6,clock,0);
		Set_3x1_Direction('b','f',9,clock,0);
		Set_3x1_Direction('b','f',8,clock,0);
		Set_3x1_Direction('b','f',7,clock,0);
		Set_3x1_Direction('b','f',4,clock,0);
		
		Set_3x1_Direction('r','f',1,clock,0);
		Set_3x1_Direction('r','f',2,clock,0);
		Set_3x1_Direction('r','f',3,clock,0);
		Set_3x1_Direction('r','f',6,clock,0);
		Set_3x1_Direction('r','f',9,clock,0);
		Set_3x1_Direction('r','f',8,clock,0);
		Set_3x1_Direction('r','f',7,clock,0);
		Set_3x1_Direction('r','f',4,clock,0);
		loop-- ;
		}
		loop = 2;
		clock = 200;
		while (loop != 0){
		Set_3x1_Direction('b','f',1,clock,0);
		Set_3x1_Direction('b','f',2,clock,0);
		Set_3x1_Direction('b','f',3,clock,0);
		Set_3x1_Direction('b','f',6,clock,0);
		Set_3x1_Direction('b','f',9,clock,0);
		Set_3x1_Direction('b','f',8,clock,0);
		Set_3x1_Direction('b','f',7,clock,0);
		Set_3x1_Direction('b','f',4,clock,0);
		loop-- ;
		}
		loop = 10;
		clock = 25;
		while(loop != 0)
		{
		Set_3x1_Direction('b','h',1,clock,0);
		Set_3x1_Direction('b','h',4,clock,0);
		Set_3x1_Direction('b','h',7,clock,0);
		Set_3x1_Direction('b','h',8,clock,0);
		Set_3x1_Direction('b','h',9,clock,0);
		Set_3x1_Direction('b','h',6,clock,0);
		Set_3x1_Direction('b','h',3,clock,0);
		Set_3x1_Direction('b','h',2,clock,0);
		
		Set_3x1_Direction('r','h',1,clock,0);
		Set_3x1_Direction('r','h',4,clock,0);
		Set_3x1_Direction('r','h',7,clock,0);
		Set_3x1_Direction('r','h',8,clock,0);
		Set_3x1_Direction('r','h',9,clock,0);
		Set_3x1_Direction('r','h',6,clock,0);
		Set_3x1_Direction('r','h',3,clock,0);
		Set_3x1_Direction('r','h',2,clock,0);
		loop-- ;
		}
		loop = 12;
		while(loop != 0)
		{
		Set_3x1_Direction('b','h',1,clock,0);
		Set_3x1_Direction('r','h',4,clock,0);
		Set_3x1_Direction('b','h',7,clock,0);
		Set_3x1_Direction('r','h',8,clock,0);
		Set_3x1_Direction('b','h',9,clock,0);
		Set_3x1_Direction('r','h',6,clock,0);
		Set_3x1_Direction('b','h',3,clock,0);
		Set_3x1_Direction('r','h',2,clock,0);
		loop --;
		}
		loop = 2;
		clock = 200;
		while(loop != 0)
		{
		Set_3x1_Direction('b','h',1,clock,0);
		Set_3x1_Direction('r','h',4,clock,0);
		Set_3x1_Direction('b','h',7,clock,0);
		Set_3x1_Direction('r','h',8,clock,0);
		Set_3x1_Direction('b','h',9,clock,0);
		Set_3x1_Direction('r','h',6,clock,0);
		Set_3x1_Direction('b','h',3,clock,0);
		Set_3x1_Direction('r','h',2,clock,0);
		clock += 400;
		loop --;
		}
		clock = 30;
		while(clk != clock)
		{
		Set_3x1_Direction('r','h',2,clock,0);
		clk ++;
		}
		clock = 50;
		while(clk != clock)
		{
		Set_3x1_Direction('b','h',1,clock,0);
		clk ++;
		}
		openblue(0);
		loop = loopcontrol;
	}

    usbInit();

    /* enforce re-enumeration, do this while interrupts are disabled! */
    usbDeviceDisconnect();
    _delay_ms(300);
    usbDeviceConnect();

    /* enable global interrupts */
    sei();

    /* main event loop */
    for(;;)
    {
        usbPoll();
    }

    return 0;
}
void show_3x3_Motion(char Color,char Direction,int reverse,int smooth,int clock)
{
	int min,max,count,tmp = 1,clk = 0,round = 1;
	if(reverse == 0)
	{
		min = 1;
		max = 4;
		count = min;
		while(max < 11){
		while (clk != clock){
			while (count != max){
				Set_3x1_Direction(Color,Direction,count,clock,1);
				count ++;}
			count = min;
			clk ++;}
		clk = 0;
		openblue(0);
		if(smooth == 0)
		_delay_ms(Wait);
		if(max == 10)max = 10;
		else max += 3;
		if (tmp == 3){
		round = 0;
		tmp = 1;}
		if (smooth == 1 && round){
		min = 1;
		tmp ++;}
		else min += 3;
		count = min;
		if (min > max){ 
		openblue(0);
		_delay_ms(Wait);
		return;}}}
	else{
	min = 6;
	max = 9;
	count = max;
	while (min > -1){
	while (clk != clock){
			while (count != min){
				Set_3x1_Direction(Color,Direction,count,clock,1);
				count --;}
			count = max;
			clk ++;}
		clk = 0;
		openblue(0);
		if(smooth == 0)
		_delay_ms(Wait);
		if(min == 0)min = 0;
		else min -= 3;
		if (tmp == 3){
		round = 0;
		tmp = 1;}
		if (smooth == 1 && round){
		max = 9;
		tmp ++;}
		else max -= 3;
		count = max;
		if (min > max){ 
		openblue(0);
		_delay_ms(Wait);
		return;}}}
}
void show_3x1_Motion(char Color,char Direction,int reverse,int clock)
{
	int count = 0;
	if(reverse == 0)count = 1;
	else count = 9;

if(reverse == 0){
	while(count <= 9 ){
	if(Color == 'b') Set_3x1_Direction(Color,Direction,count,clock,0);
	else Set_3x1_Direction(Color,Direction,count,clock,0);
	count ++;}
	openblue(0);
	_delay_ms(Wait);}
else{
	while(count >= 1 ){
	if(Color == 'b') Set_3x1_Direction(Color,Direction,count,clock,0);
	else Set_3x1_Direction(Color,Direction,count,clock,0);
	count --;}
	openblue(0);
	_delay_ms(Wait);}
}
void Set_3x1_Direction(char Color,char Direction,int roll,int clock,int plain)
{
	int count = 3;
	int begin = 0;
	if(Direction == 'v') begin = 2*(roll - 1) + roll;
	else if(Direction == 'h'){
		if (roll % 3 == 1)begin = (roll / 3) + 1;
		else if (roll % 3 == 2)begin = (roll / 3) + 10;
		else if (roll % 3 == 0)begin = (roll / 3) + 18;}
	else if (Direction == 'f' && plain == 0){
		if (roll % 3 == 1)begin = (roll / 3) + 1;
		else if (roll % 3 == 2)begin = (roll / 3) + 4;
		else if (roll % 3 == 0)begin = (roll / 3) + 6;}
	else if (Direction == 'f' && plain == 1) begin = roll;		
	int tmp = begin;
	int clk = 0;
	if (plain == 0){
	while(clk != clock){
		while ( count != 0){
			if(Color == 'b')
			openblue(begin);
			else openred(begin);
			_delay_ms(0.6);
			count --;
			if(Direction =='v')begin++;
			else if (Direction =='h')begin += 3;
			else begin += 9;
			}
		count = 3;
		begin = tmp;
		clk++;}}
	else{
		while ( count != 0){
			if(Color == 'b')openblue(begin);
			else openred(begin);
			_delay_ms(0.6);
			count --;
			if(Direction =='v')begin++;
			else if (Direction =='h')begin += 3;
			else begin += 9;}}
			
}
void openblue (int LED)
{
	if(LED == 0){		
	DDRC  = 0b00000000;
	DDRB  = 0b00000000;
        PORTC = 0b00000000; 		//0
	PORTB = 0b00000000;}
	else if(LED == 1){
	DDRC  = 0b00010100;
	DDRB  = 0b00000000;
        PORTC = 0b00010000; 		//1
	PORTB = 0b00000000;}
	else if (LED == 2){
	DDRC  = 0b00010001;
	DDRB  = 0b00000000;
	PORTC = 0b00010000;		//2
	PORTB = 0b00000000;}	
	else if (LED == 3){
	DDRC  = 0b00110000;
	DDRB  = 0b00000000;
	PORTC = 0b00010000;		//3
	PORTB = 0b00000000;}
	else if (LED == 4){
	DDRC  = 0b00011000;
	DDRB  = 0b00000000;
        PORTC = 0b00010000; 		//4
	PORTB = 0b00000000;}
	else if (LED == 5){
	DDRC  = 0b00010010;
	DDRB  = 0b00000000;
	PORTC = 0b00010000;		//5
	PORTB = 0b00000000;}
	else if (LED == 6){
	DDRC  = 0b00010000;
	DDRB  = 0b00010000;
	PORTC = 0b00010000;		// 6
	PORTB = 0b00000000;}
	else if (LED == 7){
	DDRC  = 0b00010000;
	DDRB  = 0b00000100;		// 7
	PORTC = 0b00010000;
	PORTB = 0b00000000;}
	else if (LED == 8){
	DDRC  = 0b00000010;
	DDRB  = 0b00010000;
	PORTC = 0b00000010;		// 8
	PORTB = 0b00000000;}
	else if (LED == 9){
	DDRC  = 0b00000010;
	DDRB  = 0b00000100;
	PORTC = 0b00000010;		// 9
	PORTB = 0b00000000;}
	else if (LED == 10){
	DDRC  = 0b00000101;
	DDRB  = 0b00000000;
	PORTC = 0b00000100;		// 10
	PORTB = 0b00000000;}
	else if (LED == 11){
	DDRC  = 0b00100100;
	DDRB  = 0b00000000;
	PORTC = 0b00000100;		// 11
	PORTB = 0b00000000;}
	else if (LED == 12){
	DDRC  = 0b00001100;
	DDRB  = 0b00000000;
	PORTC = 0b00000100;		// 12
	PORTB = 0b00000000;}
	else if (LED == 13){
	DDRC  = 0b00000110;
	DDRB  = 0b00000000;
	PORTC = 0b00000100;		// 13
	PORTB = 0b00000000;}
	else if (LED == 14){
	DDRC  = 0b00000100;
	DDRB  = 0b00010000;
	PORTC = 0b00000100;		// 14
	PORTB = 0b00000000;}
	else if (LED == 15){
	DDRC  = 0b00000100;
	DDRB  = 0b00000100;
	PORTC = 0b00000100;		// 15
	PORTB = 0b00000000;}
	else if (LED == 16){
	DDRC  = 0b00001010;
	DDRB  = 0b00000000;
	PORTC = 0b00001000;		// 16
	PORTB = 0b00000000;}
	else if (LED == 17){
	DDRC  = 0b00001000;
	DDRB  = 0b00010000;
	PORTC = 0b00001000;		// 17
	PORTB = 0b00000000;}
	else if (LED == 18){	
	DDRC  = 0b00001000;
	DDRB  = 0b00000100;
	PORTC = 0b00001000;		// 18
	PORTB = 0b00000000;}
	else if (LED == 19){
	DDRC  = 0b00100001;
	DDRB  = 0b00000000;
        PORTC = 0b00000001; 		// 19
	PORTB = 0b00000000;}
	else if (LED == 20){	
	DDRC  = 0b00001001;
	DDRB  = 0b00000000;
        PORTC = 0b00000001; 		//20
	PORTB = 0b00000000;}
	else if (LED == 21){
	DDRC  = 0b00000011;
	DDRB  = 0b00000000;
        PORTC = 0b00000001; 		//21
	PORTB = 0b00000000;}
	else if (LED ==	22){
	DDRC  = 0b00000001;
	DDRB  = 0b00010000;
        PORTC = 0b00000001; 		//22
	PORTB = 0b00000000;}
	else if (LED == 23){
	DDRC  = 0b00000001;
	DDRB  = 0b00000100;
        PORTC = 0b00000001; 		//23
	PORTB = 0b00000000;}
	else if (LED == 24){
	DDRC  = 0b00101000;
	DDRB  = 0b00000000;
        PORTC = 0b00100000; 		//24
	PORTB = 0b00000000;}
	else if (LED == 25){	
	DDRC  = 0b00100010;
	DDRB  = 0b00000000;
        PORTC = 0b00100000; 		//25
	PORTB = 0b00000000;}
	else if (LED == 26){
	DDRC  = 0b00100000;
	DDRB  = 0b00010000;
        PORTC = 0b00100000; 		//26
	PORTB = 0b00000000;}
	else if (LED == 27){
	DDRC  = 0b00100000;
	DDRB  = 0b00000100;
        PORTC = 0b00100000; 		//27
	PORTB = 0b00000000;}
}
void openred (int LED)
{
	if(LED == 1){	
	DDRC  = 0b00010100;
	DDRB  = 0b00000000;
        PORTC = 0b00000100; 		//1
	PORTB = 0b00000000;}
	else if (LED == 2){
	DDRC  = 0b00010001;
	DDRB  = 0b00000000;
	PORTC = 0b00000001;		//2
	PORTB = 0b00000000;}
	else if (LED == 3){
	DDRC  = 0b00110000;
	DDRB  = 0b00000000;
	PORTC = 0b00100000;		//3
	PORTB = 0b00000000;}
	else if (LED == 4){
	DDRC  = 0b00011000;
	DDRB  = 0b00000000;
        PORTC = 0b00001000; 		//4
	PORTB = 0b00000000;}
	else if (LED == 5){
	DDRC  = 0b00010010;
	DDRB  = 0b00000000;
	PORTC = 0b00000010;		//5
	PORTB = 0b00000000;}
	else if (LED == 6){
	DDRC  = 0b00010000;
	DDRB  = 0b00010000;
	PORTC = 0b00000000;		// 6
	PORTB = 0b00010000;}
	else if (LED == 7){
	DDRC  = 0b00010000;
	DDRB  = 0b00000100;		// 7
	PORTC = 0b00000000;
	PORTB = 0b00000100;}
	else if (LED == 8){
	DDRC  = 0b00000010;
	DDRB  = 0b00010000;
	PORTC = 0b00000000;		// 8
	PORTB = 0b00010000;}
	else if (LED == 9){
	DDRC  = 0b00000010;
	DDRB  = 0b00000100;
	PORTC = 0b00000000;		// 9
	PORTB = 0b00000100;}
	else if (LED == 10){
	DDRC  = 0b00000101;
	DDRB  = 0b00000000;
	PORTC = 0b00000001;		// 10
	PORTB = 0b00000000;}
	else if (LED == 11){
	DDRC  = 0b00100100;
	DDRB  = 0b00000000;
	PORTC = 0b00100000;		// 11
	PORTB = 0b00000000;}
	else if (LED == 12){
	DDRC  = 0b00001100;
	DDRB  = 0b00000000;
	PORTC = 0b00001000;		// 12
	PORTB = 0b00000000;}
	else if (LED == 13){
	DDRC  = 0b00000110;
	DDRB  = 0b00000000;
	PORTC = 0b00000010;		// 13
	PORTB = 0b00000000;}
	else if (LED == 14){
	DDRC  = 0b00000100;
	DDRB  = 0b00010000;
	PORTC = 0b00000000;		// 14
	PORTB = 0b00010000;}
	else if (LED == 15){
	DDRC  = 0b00000100;
	DDRB  = 0b00000100;
	PORTC = 0b00000000;		// 15
	PORTB = 0b00000100;}
	else if (LED == 16){
	DDRC  = 0b00001010;
	DDRB  = 0b00000000;
	PORTC = 0b00000010;		// 16
	PORTB = 0b00000000;}
	else if (LED == 17){
	DDRC  = 0b00001000;
	DDRB  = 0b00010000;
	PORTC = 0b00000000;		// 17
	PORTB = 0b00010000;}
	else if (LED == 18){	
	DDRC  = 0b00001000;
	DDRB  = 0b00000100;
	PORTC = 0b00000000;		// 18
	PORTB = 0b00000100;}
	else if (LED == 19){
	DDRC  = 0b00100001;
	DDRB  = 0b00000000;
        PORTC = 0b00100000; 		// 19
	PORTB = 0b00000000;}
	else if (LED == 20){	
	DDRC  = 0b00001001;
	DDRB  = 0b00000000;
        PORTC = 0b00001000; 		//20
	PORTB = 0b00000000;}
	else if (LED == 21){
	DDRC  = 0b00000011;
	DDRB  = 0b00000000;
        PORTC = 0b00000010; 		//21
	PORTB = 0b00000000;}
	else if (LED ==	22){
	DDRC  = 0b00000001;
	DDRB  = 0b00010000;
        PORTC = 0b00000000; 		//22
	PORTB = 0b00010000;}
	else if (LED == 23){
	DDRC  = 0b00000001;
	DDRB  = 0b00000100;
        PORTC = 0b00000000; 		//23
	PORTB = 0b00000100;}
	else if (LED == 24){
	DDRC  = 0b00101000;
	DDRB  = 0b00000000;
        PORTC = 0b00001000; 		//24
	PORTB = 0b00000000;}
	else if (LED == 25){	
	DDRC  = 0b00100010;
	DDRB  = 0b00000000;
        PORTC = 0b00000010; 		//25
	PORTB = 0b00000000;}
	else if (LED == 26){
	DDRC  = 0b00100000;
	DDRB  = 0b00010000;
        PORTC = 0b00000000; 		//26
	PORTB = 0b00010000;}
	else if (LED == 27){
	DDRC  = 0b00100000;
	DDRB  = 0b00000100;
        PORTC = 0b00000000; 		//27
	PORTB = 0b00000100;}
}

/* ------------------------------------------------------------------------- */
