from practicum import McuBoard

RQ_SET_LED    = 0
RQ_GET_SWITCH = 1
RQ_GET_LIGHT  = 2


####################################
class PeriBoard(McuBoard):

    ################################
    def setLed(self, led_no, led_val):
        '''
        Set status of LED led_no on peripheral board to led_val
        '''
	self.usb_write(RQ_SET_LED, index=led_no, value=led_val)

    ################################
    def setLedValue(self, value):
        '''
        Display value's 3 LSBs on peripheral board's LEDs
        '''
        self.setLed(0, value&1)
        self.setLed(1, (value>>1)&1)
        self.setLed(2, (value>>2)&1)

    ################################
    def getSwitch(self):
        '''
        Return a boolean value indicating whether the switch on the peripheral
        board is currently pressed
        '''
	tup = self.usb_read(RQ_GET_SWITCH, length=1)
	return bool(tup[0])

    ################################
    def getLight(self):
        '''
        Return the current reading of light sensor on peripheral board
        '''
        tup = self.usb_read(RQ_GET_LIGHT, length=2)
        return int(tup[1]*256 + tup[0])%1024

